local a,T=...

local NCT=CreateFrame('frame',a)
local NCTPanel=CreateFrame('frame',a..'Panel')
local CombatFeedbackText,notemp=CombatFeedbackText,true
local _,cevent,checkbox,checkboxname,text,unit
local checkboxnum=0

NoCombatText_SV={}
T={
	def={
		pla={dam=true,hea=true,ene=true,txt=true,},
		pet={dam=true,hea=true,ene=true,txt=true,},
	},
	opt={
		pla={dam,hea,ene,txt,},
		pet={dam,hea,ene,txt,},
	},
	reg={
		pla={all,any,},
		pet={all,any,},
	},
	temp={},
}

NCT:RegisterEvent('ADDON_LOADED')
NCT:SetScript('OnEvent',function(self,event,addon)
	if event ~= 'ADDON_LOADED' or addon ~= a then return end
	if NoCombatText_SV.saved then
		for k1,v1 in pairs(T.def) do
			if NoCombatText_SV[k1] == nil then
				NoCombatText_SV[k1]=T.def[k1]
			end
			for k2,v2 in pairs(v1) do
				if NoCombatText_SV[k1][k2] == nil then
					NoCombatText_SV[k1][k2]=T.def[k1][k2]
				elseif type(NoCombatText_SV[k1][k2]) ~= 'boolean' then
					NoCombatText_SV[k1][k2]=T.def[k1][k2]
				end
			end
		end
		T.opt=NCT:DeepCopy(NoCombatText_SV)
		NoCombatText_SV.saved=true
	else
		T.opt=NCT:DeepCopy(T.def)
		NoCombatText_SV=NCT:DeepCopy(T.def)
		NoCombatText_SV.saved=true
	end
	NCT:Options()
	NCT:Register()
	NCT:UnregisterEvent('ADDON_LOADED')
end)

local function NCT_PlayerOnEvent(self,event,...)
	text='none' unit,cevent,_=...
	if event == 'UNIT_COMBAT' and unit == self.unit then
		for k in pairs(CombatFeedbackText) do if k == cevent then text=cevent end end
		if cevent == 'WOUND' then if not T.opt.pla.dam then CombatFeedback_OnCombatEvent(self,select(2,...)) end
		elseif cevent == 'HEAL' then if not T.opt.pla.hea then CombatFeedback_OnCombatEvent(self,select(2,...)) end
		elseif cevent == 'ENERGIZE' then if not T.opt.pla.ene then CombatFeedback_OnCombatEvent(self,select(2,...)) end
		elseif cevent == text then if not T.opt.pla.txt then CombatFeedback_OnCombatEvent(self,select(2,...)) end
		else CombatFeedback_OnCombatEvent(self,select(2,...)) end
	else
		PlayerFrame_OnEvent(self,event,...)
	end
end

local function NCT_PetOnEvent(self,event,...)
	text='none' unit,cevent,_=...
	if event == 'UNIT_COMBAT' and unit == self.unit then
		for k in pairs(CombatFeedbackText) do if k == cevent then text=cevent end end
		if cevent == 'WOUND' then if not T.opt.pet.dam then CombatFeedback_OnCombatEvent(self,select(2,...)) end
		elseif cevent == 'HEAL' then if not T.opt.pet.hea then CombatFeedback_OnCombatEvent(self,select(2,...)) end
		elseif cevent == 'ENERGIZE' then if not T.opt.pet.ene then CombatFeedback_OnCombatEvent(self,select(2,...)) end
		elseif cevent == text then if not T.opt.pet.txt then CombatFeedback_OnCombatEvent(self,select(2,...)) end
		else CombatFeedback_OnCombatEvent(self,select(2,...)) end
	else
		PetFrame_OnEvent(self,event,...)
	end
end

function NCT:Register()
	T.reg.pla.all=true
	T.reg.pet.all=true
	T.reg.pla.any=false
	T.reg.pet.any=false
	for k,v in pairs(T.opt.pla) do
		if v then T.reg.pla.any=true
		else T.reg.pla.all=false end
	end
	for k,v in pairs(T.opt.pet) do
		if v then T.reg.pet.any=true
		else T.reg.pet.all=false end
	end
	PlayerFrame:SetScript('OnEvent',nil)
	PlayerFrame:UnregisterEvent('UNIT_COMBAT')
	PetFrame:SetScript('OnEvent',nil)
	PetFrame:UnregisterEvent('UNIT_COMBAT')
	if T.opt.pla.all then
		PlayerFrame:SetScript('OnEvent',PlayerFrame_OnEvent)
	elseif T.opt.pla.any then
		PlayerFrame:RegisterUnitEvent('UNIT_COMBAT','player','vehicle')
		PlayerFrame:SetScript('OnEvent',NCT_PlayerOnEvent)
	else
		PlayerFrame:RegisterUnitEvent('UNIT_COMBAT','player','vehicle')
		PlayerFrame:SetScript('OnEvent',PlayerFrame_OnEvent)
	end
	if T.opt.pet.all then
		PetFrame:SetScript('OnEvent',PetFrame_OnEvent)
	elseif T.opt.pet.any then
		PetFrame:RegisterUnitEvent('UNIT_COMBAT','pet','player')
		PetFrame:SetScript('OnEvent',NCT_PetOnEvent)
	else
		PetFrame:RegisterUnitEvent('UNIT_COMBAT','pet','player')
		PetFrame:SetScript('OnEvent',PetFrame_OnEvent)
	end
end

function NCT:CreateCheckBox(xloc,yloc,text)
	checkboxnum=checkboxnum+1
	checkboxname=a..'CheckBox'..format('%02i',checkboxnum)
	checkbox=CreateFrame('CheckButton',checkboxname,NCTPanel,'InterfaceOptionsCheckButtonTemplate')
	checkbox:SetPoint('TOPLEFT',NCTPanel,'TOPLEFT',xloc,yloc)
	_G[checkboxname..'Text']:SetText('|cffffd100'..strlower(text)..'|cffffd100)')
	return checkbox
end

function NCT:Options()
	NCTPanel.name=a
	InterfaceOptions_AddCategory(NCTPanel,a)
	NCTTitle=NCTPanel:CreateFontString('$parentTitle','ARTWORK','GameFontNormalLarge')
	NCTTitle:SetPoint('TOPLEFT',NCTPanel,'TOPLEFT',16,-16)
	NCTTitle:SetText(DISABLE)
	NCTCheckBox01=NCT:CreateCheckBox(16,-64,''..PLAYER..' '..DAMAGE..' '..EVENTS_LABEL..' (|cffffff002413|cffffd100/|cffffffff2413')
	NCTCheckBox02=NCT:CreateCheckBox(16,-96,''..PLAYER..' '..VOICEMACRO_LABEL_HEALME1..' '..EVENTS_LABEL..' (|cff00ff002413')
	NCTCheckBox03=NCT:CreateCheckBox(16,-128,''..PLAYER..' '..COMBAT_TEXT_SHOW_ENERGIZE_TEXT..' (|cff69ccf02413')
	NCTCheckBox04=NCT:CreateCheckBox(16,-160,''..PLAYER..' '..COMBAT..' '..EVENTS_LABEL..' (|cffffffff'..COMBAT_TEXT_SHOW_DODGE_PARRY_MISS_TEXT..'')
	NCTCheckBox05=NCT:CreateCheckBox(16,-192,''..PET..' '..DAMAGE..' '..EVENTS_LABEL..' (|cffffff002413|cffffd100/|cffffffff2413')
	NCTCheckBox06=NCT:CreateCheckBox(16,-224,''..PET..' '..VOICEMACRO_LABEL_HEALME1..' '..EVENTS_LABEL..' (|cff00ff002413')
	NCTCheckBox07=NCT:CreateCheckBox(16,-256,''..PET..' '..COMBAT_TEXT_SHOW_ENERGIZE_TEXT..' (|cff69ccf02413')
	NCTCheckBox08=NCT:CreateCheckBox(16,-288,''..PET..' '..COMBAT..' '..EVENTS_LABEL..' (|cffffffff'..COMBAT_TEXT_SHOW_DODGE_PARRY_MISS_TEXT..'')
	NCTCheckBox01:SetScript('PostClick',function()T.opt.pla.dam=NCTCheckBox01:GetChecked()NCT:Register()end)
	NCTCheckBox02:SetScript('PostClick',function()T.opt.pla.hea=NCTCheckBox02:GetChecked()NCT:Register()end)
	NCTCheckBox03:SetScript('PostClick',function()T.opt.pla.ene=NCTCheckBox03:GetChecked()NCT:Register()end)
	NCTCheckBox04:SetScript('PostClick',function()T.opt.pla.txt=NCTCheckBox04:GetChecked()NCT:Register()end)
	NCTCheckBox05:SetScript('PostClick',function()T.opt.pet.dam=NCTCheckBox05:GetChecked()NCT:Register()end)
	NCTCheckBox06:SetScript('PostClick',function()T.opt.pet.hea=NCTCheckBox06:GetChecked()NCT:Register()end)
	NCTCheckBox07:SetScript('PostClick',function()T.opt.pet.ene=NCTCheckBox07:GetChecked()NCT:Register()end)
	NCTCheckBox08:SetScript('PostClick',function()T.opt.pet.txt=NCTCheckBox08:GetChecked()NCT:Register()end)
	NCTPanel.okay=function()
		NoCombatText_SV=NCT:DeepCopy(T.opt)
		notemp=true
	end
	NCTPanel.cancel=function()
		T.opt=NCT:DeepCopy(T.temp)
		notemp=true
		NCT:Register()
	end
	NCTPanel.default=function()
		T.opt=NCT:DeepCopy(T.def)
		NoCombatText_SV=NCT:DeepCopy(T.def)
		NCT:SetCheckBoxes()
		NCT:Register()
	end
	NCTPanel.refresh=function()
		NCT:SetCheckBoxes()
		if notemp then T.temp=NCT:DeepCopy(T.opt) notemp=false end
	end
	SLASH_NOCOMBATTEXT_1='/nocombattext'
	SLASH_NOCOMBATTEXT_2='/nct'
	SlashCmdList['NOCOMBATTEXT_']=function()InterfaceOptionsFrame_OpenToCategory(a)end
end

function NCT:SetCheckBoxes()
	NCTCheckBox01:SetChecked(T.opt.pla.dam)
	NCTCheckBox02:SetChecked(T.opt.pla.hea)
	NCTCheckBox03:SetChecked(T.opt.pla.ene)
	NCTCheckBox04:SetChecked(T.opt.pla.txt)
	NCTCheckBox05:SetChecked(T.opt.pet.dam)
	NCTCheckBox06:SetChecked(T.opt.pet.hea)
	NCTCheckBox07:SetChecked(T.opt.pet.ene)
	NCTCheckBox08:SetChecked(T.opt.pet.txt)
end

-- following function from http://lua-users.org/wiki/CopyTable

function NCT:DeepCopy(orig)
	local orig_type=type(orig)
	local copy
	if orig_type == 'table' then
		copy={}
		for orig_key,orig_value in next,orig,nil do
			copy[NCT:DeepCopy(orig_key)]=NCT:DeepCopy(orig_value)
		end
		setmetatable(copy,NCT:DeepCopy(getmetatable(orig)))
	else -- number,string,boolean,etc
		copy=orig
	end
	return copy
end

--	NoCombatText: below code pasted from http://www.curse.com/addons/wow/blizzbugssuck
--	NoCombatText: still broken in 6.2.0.20253

--	Fix InterfaceOptionsFrame_OpenToCategory not actually opening the category (and not even scrolling to it)
--	Confirmed still broken in 6.0.3.19243

function get_panel_name(panel)
	local tp=type(panel)
	local cat=INTERFACEOPTIONS_ADDONCATEGORIES
	if tp == 'string' then
		for i=1,#cat do
			local p=cat[i]
			if p.name == panel then
				if p.parent then
					return get_panel_name(p.parent)
				else
					return panel
				end
			end
		end
	elseif tp == 'table' then
		for i=1,#cat do
			local p=cat[i]
			if p == panel then
				if p.parent then
					return get_panel_name(p.parent)
				else
					return panel.name
				end
			end
		end
	end
end
function InterfaceOptionsFrame_OpenToCategory_Fix(panel)
	if IOF_OTC_F_donotrun or InCombatLockdown() then return end
	local panelName=get_panel_name(panel)
	if not panelName then return end -- if its not part of our list return early
	local noncollapsedHeaders={}
	local shownpanels=0
	local mypanel
	local t={}
	local cat=INTERFACEOPTIONS_ADDONCATEGORIES
	for i=1,#cat do
		local panel=cat[i]
		if not panel.parent or noncollapsedHeaders[panel.parent] then
			if panel.name == panelName then
				panel.collapsed=true
				t.element=panel
				InterfaceOptionsListButton_ToggleSubCategories(t)
				noncollapsedHeaders[panel.name]=true
				mypanel=shownpanels + 1
			end
			if not panel.collapsed then
				noncollapsedHeaders[panel.name]=true
			end
			shownpanels=shownpanels + 1
		end
	end
	local Smin,Smax=InterfaceOptionsFrameAddOnsListScrollBar:GetMinMaxValues()
	if shownpanels > 15 and Smin < Smax then
		local val=(Smax/(shownpanels-15))*(mypanel-2)
		InterfaceOptionsFrameAddOnsListScrollBar:SetValue(val)
	end
	IOF_OTC_F_donotrun=true
	InterfaceOptionsFrame_OpenToCategory(panel)
	IOF_OTC_F_donotrun=false
end
hooksecurefunc('InterfaceOptionsFrame_OpenToCategory',InterfaceOptionsFrame_OpenToCategory_Fix)